unit F.Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, iORM.DB.Components.ConnectionDef, iORM.AbstractionLayer.Framework.FMX,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.Edit;

type
  TMainForm = class(TForm)
    ioFMX1: TioFMX;
    SQLiteConn: TioSQLiteConnectionDef;
    SQLMon: TioSQLMonitor;
    Panel1: TPanel;
    Label1: TLabel;
    EditPersonID: TEdit;
    ButtonPerson: TButton;
    Panel2: TPanel;
    Label2: TLabel;
    EditArticleID: TEdit;
    ButtonArticle: TButton;
    CheckBoxPersonLazy: TCheckBox;
    CheckBoxArticleLazy: TCheckBox;
    procedure SQLiteConnAfterRegister(Sender: TObject);
    procedure ButtonPersonClick(Sender: TObject);
    procedure ButtonArticleClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses
  U.SampleData, M.Interfaces, M.Person, iORM;

{$R *.fmx}

procedure TMainForm.ButtonPersonClick(Sender: TObject);
var
  LPerson: IPerson;
begin
  if CheckBoxPersonLazy.IsChecked then
    // Lazy
    LPerson := io.Load<IPerson>.Lazy.ByOID(  EditPersonID.Text.ToInteger  ).ToObject
  else
    // Normal
    LPerson := io.Load<IPerson>.ByOID(  EditPersonID.Text.ToInteger  ).ToObject;

  ShowMessage(  LPerson.FullName  );
end;

procedure TMainForm.ButtonArticleClick(Sender: TObject);
var
  LArticle: IArticle;
begin
  if CheckBoxArticleLazy.IsChecked then
    // Lazy
    LArticle := io.Load<IArticle>.Lazy.ByOID(  EditArticleID.Text.ToInteger  ).ToObject
  else
    // Normal
    LArticle := io.Load<IArticle>.ByOID(  EditArticleID.Text.ToInteger  ).ToObject;

  ShowMessage(  Format('%s - %m', [LArticle.Name, LArticle.Price])  );
end;

procedure TMainForm.SQLiteConnAfterRegister(Sender: TObject);
begin
  TSampleData.CheckForSampleData;
end;

end.
