unit M.Person;

interface

uses
  M.Interfaces, iORM.Attributes;

type
{$RTTI EXPLICIT METHODS([vcPublic, vcProtected])}

  [ioEntity(ioFields), diImplements(IPerson)]
  TPerson = class(TInterfacedObject, IPerson)
  private
    FID: Integer;
    FFirstName:String;
    FLastName: String;
  protected
    function GetID: Integer;
    function GetFirstName: String;
    function GetLastName: String;
    function GetFullName: String;
    procedure SetID(const Value: Integer);
    procedure SetFirstName(const Value: String);
    procedure SetLastName(const Value: String);
  public
    constructor Create; reintroduce;
    property ID:Integer read GetID write SetID;
    property FirstName:String read GetFirstName write SetFirstName;
    property LastName:String read GetLastName write SetLastName;
    property FullName:String read GetFullName;
  end;

implementation

uses
  System.SysUtils;

{ TPerson }

constructor TPerson.Create;
begin
  inherited;
end;

function TPerson.GetFirstName: String;
begin
  Result := FFirstName;
end;

function TPerson.GetFullName: String;
begin
  Result := Format('%s %s',[FFirstName, FLastName]);
end;

function TPerson.GetID: Integer;
begin
  Result := FID;
end;

function TPerson.GetLastName: String;
begin
  Result := FLastName;
end;

procedure TPerson.SetFirstName(const Value: String);
begin
  FFirstName := Value;
end;

procedure TPerson.SetID(const Value: Integer);
begin
  FID := Value;
end;

procedure TPerson.SetLastName(const Value: String);
begin
  FLastName := Value;
end;

end.
