unit Form.Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

const
  Max =7000000;

type
  TMainForm = class(TForm)
    Memo1: TMemo;
    ButtonFor: TButton;
    ButtonParallelFor: TButton;
    procedure ButtonForClick(Sender: TObject);
    procedure ButtonParallelForClick(Sender: TObject);
  private
    function IsPrime(N: Integer): Boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses
  System.Diagnostics, System.Threading, System.SyncObjs;

{$R *.dfm}

procedure TMainForm.ButtonForClick(Sender: TObject);
var
  I, Tot: Integer;
  SW: TStopWatch;
begin
  Tot := 0;
  SW := TStopWatch.Create;
  SW.Start;

  // Loop
  for I := 1 to Max do
  begin
   if IsPrime(I) then
      Inc(Tot);
  end;

  SW.Stop;
  Memo1.Lines.Add(Format('Sequential For loop. Time (in milliseconds): %d - Primes found: %d', [SW.ElapsedMilliseconds,Tot]));
end;




procedure TMainForm.ButtonParallelForClick(Sender: TObject);
var
  Tot: Integer;
  SW: TStopWatch;
begin
  Tot := 0;
  SW := TStopWatch.Create;
  SW.Start;

  // Parallel loop
  TParallel.For(2, 1 , Max,
    procedure(I:Int64)
    begin
     if IsPrime(I) then
      TInterlocked.Increment(Tot);
    end
  );

  SW.Stop;
  Memo1.Lines.Add(Format('Parallel For loop. Time (in milliseconds): %d - Primes found: %d', [SW.ElapsedMilliseconds,Tot]));
end;




function TMainForm.IsPrime(N: Integer): Boolean;
var
  Test, k: Integer;
begin
  if N <= 3 then
    IsPrime := N > 1
  else if ((N mod 2) = 0) or ((N mod 3) = 0) then
    IsPrime := False
  else
  begin
    IsPrime := True;
    k := Trunc(Sqrt(N));
    Test := 5;
    while Test <= k do
    begin
      if ((N mod Test) = 0) or ((N mod (Test + 2)) = 0) then
      begin
        IsPrime := False;
        break; { jump out of the for loop }
      end;
      Test := Test + 6;
    end;
  end;
end;

end.
