unit U.Factory;

interface

uses
  M.Interfaces, U.LazyLoader.Interfaces;

type

  TFactory = class
  public
    // Person
    class function LoadPerson(const AID:Integer): IPerson;
    class function LoadPersonLazy(const AID:Integer): ILazyLoader;
    // Article
    class function LoadArticle(const AID:Integer): IArticle;
    class function LoadArticleLazy(const AID:Integer): ILazyLoader;
  end;

implementation

uses iORM, U.LazyLoader;

{ TFactory }

class function TFactory.LoadPerson(const AID: Integer): IPerson;
begin
  Result := io.Load<IPerson>.ByOID(AID).ToObject;
end;

class function TFactory.LoadPersonLazy(const AID: Integer): ILazyLoader;
begin
  Result := TLazyLoader.Create(  TypeInfo(IPerson), AID  );
end;

class function TFactory.LoadArticle(const AID: Integer): IArticle;
begin
  Result := io.Load<IArticle>.ByOID(AID).ToObject;
end;

class function TFactory.LoadArticleLazy(const AID: Integer): ILazyLoader;
begin
  Result := TLazyLoader.Create(  TypeInfo(IArticle), AID  );
end;

end.
