unit F.Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, iORM.DB.Components.ConnectionDef, iORM.AbstractionLayer.Framework.FMX,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.Edit;

type
  TMainForm = class(TForm)
    ioFMX1: TioFMX;
    SQLiteConn: TioSQLiteConnectionDef;
    SQLMon: TioSQLMonitor;
    Panel1: TPanel;
    Label1: TLabel;
    EditPersonID: TEdit;
    ButtonPerson: TButton;
    ButtonPersonLazy: TButton;
    Panel2: TPanel;
    Label2: TLabel;
    EditArticleID: TEdit;
    ButtonArticle: TButton;
    ButtonArticleLazy: TButton;
    procedure SQLiteConnAfterRegister(Sender: TObject);
    procedure ButtonPersonClick(Sender: TObject);
    procedure ButtonPersonLazyClick(Sender: TObject);
    procedure ButtonArticleClick(Sender: TObject);
    procedure ButtonArticleLazyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses
  U.SampleData, M.Interfaces, U.Factory, U.LazyLoader.Interfaces, M.Person;

{$R *.fmx}

procedure TMainForm.ButtonPersonClick(Sender: TObject);
var
  LPerson: IPerson;
begin
  LPerson := TFactory.LoadPerson(  EditPersonID.Text.ToInteger  );
  ShowMessage(  LPerson.FullName  );
end;

procedure TMainForm.ButtonPersonLazyClick(Sender: TObject);
var
  LPerson: ILazyLoader<IPerson>;
begin
  LPerson := TFactory.LoadPersonLazy(  EditPersonID.Text.ToInteger  );
  ShowMessage(  LPerson.GetValue.FullName  );
//Step 1:  ShowMessage(  (LPerson.GetValue as IPerson).FullName  );
end;

procedure TMainForm.ButtonArticleClick(Sender: TObject);
var
  LArticle: IArticle;
begin
  LArticle := TFactory.LoadArticle(  EditArticleID.Text.ToInteger  );
  ShowMessage(  Format('%s - %m', [LArticle.Name, LArticle.Price])  );
end;

procedure TMainForm.ButtonArticleLazyClick(Sender: TObject);
var
  LArticle: ILazyLoader<IArticle>;
begin
  LArticle := TFactory.LoadArticleLazy(  EditArticleID.Text.ToInteger  );
  ShowMessage(  Format('%s - %m', [LArticle.GetValue.Name, LArticle.GetValue.Price])  );
//Step 1:  ShowMessage(  Format('%s - %m', [(LArticle.GetValue as IArticle).Name, (LArticle.GetValue as IArticle).Price])  );
end;

procedure TMainForm.SQLiteConnAfterRegister(Sender: TObject);
begin
  TSampleData.CheckForSampleData;
end;

end.
