unit U.Factory;

interface

uses
  M.Interfaces, U.LazyLoader.Interfaces;

type

{$region 'Step 1'}
//  TFactory = class
//  public
//    // Person
//    class function LoadPerson(const AID:Integer): IPerson;
//    class function LoadPersonLazy(const AID:Integer): ILazyLoader;
//    // Article
//    class function LoadArticle(const AID:Integer): IArticle;
//    class function LoadArticleLazy(const AID:Integer): ILazyLoader;
//  end;
{$endregion}

  TFactory = class
  public
    // Person
    class function LoadPerson(const AID:Integer): IPerson;
    class function LoadPersonLazy(const AID:Integer): ILazyLoader<IPerson>;
    // Article
    class function LoadArticle(const AID:Integer): IArticle;
    class function LoadArticleLazy(const AID:Integer): ILazyLoader<IArticle>;
  end;

implementation

uses iORM, U.LazyLoader;

{ TFactory }

class function TFactory.LoadPerson(const AID: Integer): IPerson;
begin
  Result := io.Load<IPerson>.ByOID(AID).ToObject;
end;

{$region 'Step 1'}
//  class function TFactory.LoadPersonLazy(const AID: Integer): ILazyLoader;
//  begin
//    Result := TLazyLoader.Create(  TypeInfo(IPerson), AID  );
//  end;
{$endregion}

class function TFactory.LoadPersonLazy(const AID: Integer): ILazyLoader<IPerson>;
begin
  Result := TLazyLoader<IPerson>.Create(AID);
end;

class function TFactory.LoadArticle(const AID: Integer): IArticle;
begin
  Result := io.Load<IArticle>.ByOID(AID).ToObject;
end;

{$region 'Step 1'}
//  class function TFactory.LoadArticleLazy(const AID: Integer): ILazyLoader;
//  begin
//    Result := TLazyLoader.Create(  TypeInfo(IArticle), AID  );
//  end;
{$endregion}

class function TFactory.LoadArticleLazy(const AID: Integer): ILazyLoader<IArticle>;
begin
  Result := TLazyLoader<IArticle>.Create(AID);
end;

end.
