unit U.LazyLoader;

interface

uses System.TypInfo, U.LazyLoader.Interfaces;

type

{$region 'Step 1'}
//  TLazyLoader = class(TInterfacedObject, ILazyLoader)
//  private
//    FInternalInstance: IInterface;
//    FTypeInfo: PTypeInfo;
//    FID: Integer;
//    procedure CreateInternalInstance;
//  public
//    constructor Create(const ATypeInfo:PTypeInfo; const AID:Integer);
//    function GetValue: IInterface;
//  end;
{$endregion}

  TLazyLoader<T:IInterface> = class(TInterfacedObject, ILazyLoader<T>)
  private
    FInternalInstance: T;
    FID: Integer;
    procedure CreateInternalInstance;
  public
    constructor Create(const AID:Integer);
    function GetValue: T;
  end;

implementation

uses iORM;

{ TLazyLoader }

{$region 'Step 1'}
//  constructor TLazyLoader.Create(const ATypeInfo: PTypeInfo; const AID: Integer);
//  begin
//    FInternalInstance := nil;
//    FTypeInfo := ATypeInfo;
//    FID := AID;
//  end;
{$endregion}

constructor TLazyLoader<T>.Create(const AID: Integer);
begin
  FInternalInstance := nil;
  FID := AID;
end;

{$region 'Step 1'}
//  procedure TLazyLoader.CreateInternalInstance;
//  var
//    LObj: TObject;
//  begin
//    LObj := io.Load(FTypeInfo).ByOID(FID).ToObject;
//    if not Supports(LObj, IInterface, FInternalInstance) then
//      raise Exception.Create('The instance is not an interface implementer.');
//  end;
{$endregion}

procedure TLazyLoader<T>.CreateInternalInstance;
begin
  FInternalInstance := io.Load<T>.ByOID(FID).ToObject;
end;

function TLazyLoader<T>.GetValue: T;
begin
  if not Assigned(FInternalInstance) then
    CreateInternalInstance;
  Result := FInternalInstance;
end;

end.
