unit U.SampleData;

interface

type

  TSampleData = class
  private
    class procedure CreateSamplePersons;
    class procedure CreateSampleArticles;
  public
    class procedure CheckForSampleData;
  end;

implementation

uses iORM, FireDAC.Comp.Client, M.Interfaces;

{ TSampleData }

class procedure TSampleData.CheckForSampleData;
var
  LMemTable: TFDMemTable;
begin
  LMemTable := io.SQL('select count(*) from [TPerson]').ToMemTable;
  try
    if LMemTable.Fields[0].AsInteger = 0 then
    begin
      CreateSamplePersons;
      CreateSampleArticles;
    end;
  finally
    LMemTable.Free;
  end;
end;

class procedure TSampleData.CreateSamplePersons;
var
  LPerson: IPerson;
begin
  // Maurizio Del Magno
  LPerson := io.Create<IPerson>;
  LPerson.FirstName := 'Maurizio';
  LPerson.LastName := 'Del Magno';
  io.Persist(LPerson);

  // Marco Mottadelli
  LPerson := io.Create<IPerson>;
  LPerson.FirstName := 'Marco';
  LPerson.LastName := 'Mottadelli';
  io.Persist(LPerson);

  // Omar Bossoni
  LPerson := io.Create<IPerson>;
  LPerson.FirstName := 'Omar';
  LPerson.LastName := 'Bossoni';
  io.Persist(LPerson);

  // Thomas Ranzetti
  LPerson := io.Create<IPerson>;
  LPerson.FirstName := 'Thomas';
  LPerson.LastName := 'Ranzetti';
  io.Persist(LPerson);
end;

class procedure TSampleData.CreateSampleArticles;
var
  LArticle: IArticle;
begin
  // Motherboard
  LArticle := io.Create<IArticle>;
  LArticle.Name := 'Motherboard XYZ';
  LArticle.Price := 145.50;
  io.Persist(LArticle);

  // Graphic card
  LArticle := io.Create<IArticle>;
  LArticle.Name := 'Graphic card FastG';
  LArticle.Price := 290.15;
  io.Persist(LArticle);

  // SSD
  LArticle := io.Create<IArticle>;
  LArticle.Name := 'SSD 1TB';
  LArticle.Price := 234.70;
  io.Persist(LArticle);
end;

end.
