unit U.Factory;

interface

uses
  M.Interfaces, U.LazyLoader.Interfaces;

type

{$region 'Step 1'}
//  TFactory = class
//  public
//    // Person
//    class function LoadPerson(const AID:Integer): IPerson;
//    class function LoadPersonLazy(const AID:Integer): ILazyLoader;
//    // Article
//    class function LoadArticle(const AID:Integer): IArticle;
//    class function LoadArticleLazy(const AID:Integer): ILazyLoader;
//  end;
{$endregion}
{$region 'Step 2'}
//  TFactory = class
//  public
//    // Person
//    class function LoadPerson(const AID:Integer): IPerson;
//    class function LoadPersonLazy(const AID:Integer): ILazyLoader<IPerson>;
//    // Article
//    class function LoadArticle(const AID:Integer): IArticle;
//    class function LoadArticleLazy(const AID:Integer): ILazyLoader<IArticle>;
//  end;
{$endregion}

  TFactory = class
  public
    class function Load<T:IInterface>(const AID:Integer): T;
    class function LoadLazy<T:IInterface>(const AID:Integer): ILazyLoader<T>;
  end;

implementation

uses iORM, U.LazyLoader;

{ TFactory }

{$region 'Step 2'}
//  class function TFactory.LoadPerson(const AID: Integer): IPerson;
//  begin
//    Result := io.Load<IPerson>.ByOID(AID).ToObject;
//  end;
{$endregion}

class function TFactory.Load<T>(const AID: Integer): T;
begin
  Result := io.Load<T>.ByOID(AID).ToObject;
end;

{$region 'Step 1'}
//  class function TFactory.LoadPersonLazy(const AID: Integer): ILazyLoader;
//  begin
//    Result := TLazyLoader.Create(  TypeInfo(IPerson), AID  );
//  end;
{$endregion}
{$region 'Step 2'}
//  class function TFactory.LoadPersonLazy(const AID: Integer): ILazyLoader<IPerson>;
//  begin
//    Result := TLazyLoader<IPerson>.Create(AID);
//  end;
{$endregion}

class function TFactory.LoadLazy<T>(const AID: Integer): ILazyLoader<T>;
begin
  Result := TLazyLoader<T>.Create(AID);
end;

end.
