unit U.LazyLoader;

interface

uses System.TypInfo, U.LazyLoader.Interfaces;

type

  TLazyLoader<T:IInterface> = class(TInterfacedObject, ILazyLoader<T>)
  private
    FInternalInstance: T;
    FID: Integer;
    procedure CreateInternalInstance;
  public
    constructor Create(const AID:Integer);
    function GetValue: T;
  end;

implementation

uses iORM;

{ TLazyLoader }

constructor TLazyLoader<T>.Create(const AID: Integer);
begin
  FInternalInstance := nil;
  FID := AID;
end;

procedure TLazyLoader<T>.CreateInternalInstance;
begin
  FInternalInstance := io.Load<T>.ByOID(FID).ToObject;
end;

function TLazyLoader<T>.GetValue: T;
begin
  if not Assigned(FInternalInstance) then
    CreateInternalInstance;
  Result := FInternalInstance;
end;

end.
