unit U.Factory;

interface

uses
  M.Interfaces, U.LazyLoader.Interfaces;

type

  TFactory = class
  public
    class function Load<T:IInterface>(const AID:Integer): T;
    class function LoadLazy<T:IInterface>(const AID:Integer): ILazyLoader<T>;
  end;

implementation

uses iORM, U.LazyLoader;

{ TFactory }

class function TFactory.Load<T>(const AID: Integer): T;
begin
  Result := io.Load<T>.ByOID(AID).ToObject;
end;

class function TFactory.LoadLazy<T>(const AID: Integer): ILazyLoader<T>;
begin
  Result := TLazyLoader<T>.Create(AID);
end;

end.
