unit F.Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, iORM.DB.Components.ConnectionDef, iORM.AbstractionLayer.Framework.FMX,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.Edit;

type
  TMainForm = class(TForm)
    ioFMX1: TioFMX;
    SQLiteConn: TioSQLiteConnectionDef;
    SQLMon: TioSQLMonitor;
    Panel1: TPanel;
    Label1: TLabel;
    EditPersonID: TEdit;
    ButtonPerson: TButton;
    Panel2: TPanel;
    Label2: TLabel;
    EditArticleID: TEdit;
    ButtonArticle: TButton;
    CheckBoxPersonLazy: TCheckBox;
    CheckBoxArticleLazy: TCheckBox;
    procedure SQLiteConnAfterRegister(Sender: TObject);
    procedure ButtonPersonClick(Sender: TObject);
    procedure ButtonArticleClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses
  U.SampleData, M.Interfaces, U.Factory, M.Person;

{$R *.fmx}

{$region 'Step 3'}
//  procedure TMainForm.ButtonPersonClick(Sender: TObject);
//  var
//    LPerson: IPerson;
//  begin
//  //Step 2: LPerson := TFactory.LoadPerson(  EditPersonID.Text.ToInteger  );
//    LPerson := TFactory.Load<IPerson>(  EditPersonID.Text.ToInteger  );
//    ShowMessage(  LPerson.FullName  );
//  end;
//
//  procedure TMainForm.ButtonPersonLazyClick(Sender: TObject);
//  var
//    LPerson: ILazyLoader<IPerson>;
//  begin
//    LPerson := TFactory.LoadLazy<IPerson>(  EditPersonID.Text.ToInteger  );
//    ShowMessage(  LPerson.FullName  );
//  //Step 2:  ShowMessage(  LPerson.GetValue.FullName  );
//  //Step 1:  ShowMessage(  (LPerson.GetValue as IPerson).FullName  );
//  end;
{$endregion}

procedure TMainForm.ButtonPersonClick(Sender: TObject);
var
  LPerson: IPerson;
begin
  LPerson := TFactory.Load<IPerson>(  EditPersonID.Text.ToInteger, CheckBoxPersonLazy.IsChecked  );
  ShowMessage(  LPerson.FullName  );
end;

procedure TMainForm.ButtonArticleClick(Sender: TObject);
var
  LArticle: IArticle;
begin
  LArticle := TFactory.Load<IArticle>(  EditArticleID.Text.ToInteger, CheckBoxArticleLazy.IsChecked  );
  ShowMessage(  Format('%s - %m', [LArticle.Name, LArticle.Price])  );
end;

procedure TMainForm.SQLiteConnAfterRegister(Sender: TObject);
begin
  TSampleData.CheckForSampleData;
end;

end.
