unit U.Factory;

interface

uses
  M.Interfaces;

type

{$region 'Step 1'}
//  TFactory = class
//  public
//    // Person
//    class function LoadPerson(const AID:Integer): IPerson;
//    class function LoadPersonLazy(const AID:Integer): ILazyLoader;
//    // Article
//    class function LoadArticle(const AID:Integer): IArticle;
//    class function LoadArticleLazy(const AID:Integer): ILazyLoader;
//  end;
{$endregion}
{$region 'Step 2'}
//  TFactory = class
//  public
//    // Person
//    class function LoadPerson(const AID:Integer): IPerson;
//    class function LoadPersonLazy(const AID:Integer): ILazyLoader<IPerson>;
//    // Article
//    class function LoadArticle(const AID:Integer): IArticle;
//    class function LoadArticleLazy(const AID:Integer): ILazyLoader<IArticle>;
//  end;
{$endregion}
{$region 'Step 3'}
//  TFactory = class
//  public
//    class function Load<T:IInterface>(const AID:Integer): T;
//    class function LoadLazy<T:IInterface>(const AID:Integer): ILazyLoader<T>;
//  end;
{$endregion}

  TFactory = class
  public
    class function Load<T:IInterface>(const AID:Integer; const ALazyLoad:Boolean=False): T;
  end;

implementation

uses iORM, U.LazyLoader, System.SysUtils, System.TypInfo;

{ TFactory }

class function TFactory.Load<T>(const AID: Integer; const ALazyLoad: Boolean): T;
var
  LObj: TObject;
begin
  if ALazyLoad then
  begin
    LObj := TLazyLoader.Create(  TypeInfo(T), AID  );
    if not Supports(LObj, GetTypeData(TypeInfo(T))^.Guid, Result) then
      raise Exception.Create('Interface not implemented by object.');
  end
  else
    Result := io.Load<T>.ByOID(AID).ToObject;
end;

end.
