unit U.Factory;

interface

uses
  M.Interfaces;

type

  TFactory = class
  public
    class function Load<T:IInterface>(const AID:Integer; const ALazyLoad:Boolean=False): T;
  end;

implementation

uses iORM, U.LazyLoader, System.SysUtils, System.TypInfo;

{ TFactory }

class function TFactory.Load<T>(const AID: Integer; const ALazyLoad: Boolean): T;
var
  LObj: TObject;
begin
  if ALazyLoad then
  begin
    LObj := TLazyLoader<T>.Create(  AID  );
    if not Supports(LObj, GetTypeData(TypeInfo(T))^.Guid, Result) then
      raise Exception.Create('Interface not implemented by object.');
  end
  else
    Result := io.Load<T>.ByOID(AID).ToObject;
end;

end.
